/*
 * FREE 2000
 *
 * Jason Kitcat, University of Warwick
 *
 * jeep@j-dom.demon.co.uk   http://www.j-dom.demon.co.uk/free/
 *
 */

/**
 * CryptSys Class - experimental not currently used in FREE
 * @version 0.1  26 January 2000
 * @author Jason Kitcat
 */
 
package ERServer;

public class CryptSys {

	/* This implements FREECrypt, an extremely simple encryption
	   system which cannot be regarded as secure. However it does
	   provide a certain level of protection in that it is preferable
	   to sending plain text.
	   
	   Those countries where laws do not restrict the use of encryption
	   algorithms are *STRONGLY* recommended to implement this class
	   with a widely regarded secure algorithm such as RSA.
	*/

	/* SECURITY NOTE: VERY IMPORTANT! */
	// This passphrase *MUST* be changed before you implement FREE
	// for your election. Otherwise this system is totally useless
	// NB Client and Server passphrase MUST be the same!
	private static final String phrase = "privacy";


	/**
	 * encrypts String data
	 *
	 * @param data  The data being sent for encryption
	 * @return    A string containing the encrypted data
	 */
	protected static String encrypt(String data) {

		/* SUMMARY
		   Each character in the data to be encrypted is converted to a number.
		   This number is then averaged with the average of the password's characters
		   and the index of the character.
		*/
		
		int passAvg = 0;
		int i = 0;
		int temp = 0;
		String crypted = "";
		
		while (i < phrase.length()) {
			passAvg += Character.getNumericValue(phrase.charAt(i));
			i++;
		}
		passAvg = passAvg / phrase.length();
		
		i=0;
		
		while (i < data.length()) {
			temp = (Character.getNumericValue(data.charAt(i)) + passAvg + i) / 3;
			crypted = crypted + String.valueOf(Character.forDigit(temp, 36));
			i++;
		}
		
		return crypted;

	} //EOF encrypt


	/**
	 * decrypts String data
	 *
	 * @param data  The encrypted data being sent for decryption
	 * @return    A string containing the decrypted data
	 */
	protected static String decrypt(String data) {

		int passAvg = 0;
		int i = 0;
		int temp = 0;
		String plain = "";
		
		while (i < phrase.length()) {
			passAvg += Character.getNumericValue(phrase.charAt(i));
			i++;
		}
		passAvg = passAvg / phrase.length();
		
		i=0;
		
		while (i < data.length()) {
			ERServer.frame.showInfo("char: " + Character.getNumericValue(data.charAt(i)) + "passAvg: " + passAvg);
			temp = (Character.getNumericValue(data.charAt(i)) * 3) - passAvg - i;
			ERServer.frame.showInfo("Temp: " + temp);
			plain = plain + String.valueOf(Character.forDigit(temp, 36));
			i++;
		}
		
		return plain;

	} //EOF decrypt

} //EOF Class