/*
 * FREE 2000
 *
 * Copyright (c) Jason Kitcat, University of Warwick
 *
 * jeep@thecouch.org   http://www.thecouch.org/free/
 *
 * Knoll Cottage, Sutton Place, Nr.Abinger, Dorking, Surrey RH5 6RN United Kingdom
 *
 * Tel: 07956 886 508  Fax: 0870 052 7114
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program (gpl.txt); if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 *
 */
  
package FreeClient;
 
/**
 * A simple thread which waits a certain time in milliseconds defined by
 * <code>FClient.timeOutTime</code> before closing communications.
 *
 * @version 0.4  11 November 2000
 * @author Jason Kitcat
 */
public class TimeOutThread extends Thread {

	public boolean threadStatus = true;

	public void stopThread() {
		threadStatus = false;
	}

	public void run() {
	
		while (threadStatus) {
		
			try {
				sleep(FClient.timeOutTime);
			} catch (InterruptedException e) {}

			FClient.carryOn = false;
			if (FClient.ercheck) {  // make sure we're sending errors to the right screen
				FClient.frame4.showError("Connection timed out.");
				FClient.frame4.status=false;
				FClient.frame4.jButton1.setVisible(true);
				FClient.frame4.jButton2.setVisible(true);
				FClient.frame4.showInfo("Click OK to try again.");
			} else {
				FClient.frame.showError("Connection timed out.");
				FClient.frame.voteErr();
			}
				
		} //eof while
	
	} //EOF run()

	
} //EOF TimeOutThread